/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*- */
/* Copyright (C) 2001 The Free Software Foundation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author: Ante Brkic <abrkic@linux.hr>
 * Contributions:
 *          Vlatko Kosturjak <kost@iname.com> 
 *          Arturo Espinosa <arturo@ximian.com> (team codes and minor bugs).
 *          Dario Lah <dlah@foi.hr>
 *          Robert Avilov <ravilov@linux.hr>
 */

#ifdef MSVC
/* Does Microsoft have something to sleep()? */
void sleep(int mumble)
{
}
#else
#include <unistd.h>
#endif

#include "si3d.h"

#ifdef MSVC
long random (void)
{
      return (rand());
}

#endif

void
crtaj_projektil (double x_missle, double y_missle, double z_missle)
{
  double x, y, z;
  int flag;
  int br, br1;
  int sjena_red, sjena_green, sjena_blue;
  int tracer;

  x = x_missle;
  y = y_missle;
  z = z_missle;
  flag = 1;

  do
	{
		y++;
		z += 0.5;
		if (reljef[(int) x][(int) y].vis > z)
			flag = 0;
	}
  while (y < 640);

  x = x_missle;
  y = 150 - z_missle + y_missle / 2;
  if (tenk[igrac].aktivno_oruzje == 0)
	{
		aktivni = monitor;
		for (br = 0; br < 1000; br++)
			for (br1 = 0; br1 < 300; br1++);
	}
  if (tenk[igrac].aktivno_oruzje != 0)
	{
		aktivni = za_monitor;
		blit (aktivni, za_monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		aktivni = za_monitor;
		crtaj_tenk (igrac);
	}
  if (y < 10 || y > 470 || x < 10 || x > 630)
    flag = -1;
  tracer = 0;
  if (tenk[igrac].aktivno_oruzje == 0)
    tracer = 140;
  if (flag == 1)
	{
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni, x - 1, y - 1, makecol(5,5,5));
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni, x - 1, y, makecol(5,5,5));
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni,x - 1, y + 1,makecol(5,5,5));
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni, x, y - 1,makecol(5,5,5));
		putpixel(aktivni,x, y,makecol(5+tracer,5,5));
		putpixel(aktivni,x, y + 1,makecol(5+tracer,5,5));
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni,x + 1, y - 1,makecol(5,5,5));
		putpixel(aktivni,x + 1, y,makecol(5+tracer,5,5));
		putpixel(aktivni,x + 1, y + 1,makecol(5+tracer,5,5));
	}
  if (flag == 0)
	{
//              for (br=0; br<1000; br++)
//              for (br1=0; br1<300; br1++);
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni,x - 1, y - 1,makecol(0, 200, 0));
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni,x - 1, y,makecol(0, 200, 0));
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni,x - 1, y + 1,makecol(0, 200, 0));
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni,x, y - 1,makecol(0, 200, 0));
		putpixel(aktivni,x, y,makecol(0 + tracer, 200, 0));
		putpixel(aktivni,x, y + 1,makecol(0 + tracer, 200, 0));
		if (tenk[igrac].aktivno_oruzje != 0)
			putpixel(aktivni,x + 1, y - 1,makecol(0, 200, 0));
		putpixel(aktivni,x + 1, y,makecol(0 + tracer, 200, 0));
		putpixel(aktivni,x + 1, y + 1,makecol(0 + tracer, 200, 0));
	}
  x = x_missle;
  y = y_missle;
  z = reljef[(int) x_missle][(int) y_missle].vis;
  flag = 1;

  do
	{
		y++;
		z += 0.5;
		if (reljef[(int) x][(int) y].vis > z + 5)
			flag = 0;
	}
  while (y < 640);

  x = x_missle;
  y = 150 - reljef[(int) x_missle][(int) y_missle].vis + y_missle / 2;
  if (reljef[(int) x_missle][(int) y_missle].vis < 0)
    y = 150 + y_missle / 2;
  if (y < 10 || y > 470 || x < 10 || x > 630
      || z_missle - reljef[(int) x_missle][(int) y_missle].vis < 5)
    flag = -1;
  if (flag == 1)
	{
		sjena_red = getr(getpixel(aktivni,x,y));
		sjena_green = getg(getpixel(aktivni,x,y));
		sjena_blue = getb(getpixel(aktivni,x,y));
		sjena_red -= 40;
		sjena_green -= 40;
		sjena_blue -= 40;
		if (sjena_red < 0)
			sjena_red = 0;
		if (sjena_green < 0)
			sjena_green = 0;
		if (sjena_blue < 0)
			sjena_blue = 0;
		putpixel(aktivni,x - 1, y - 1,makecol(sjena_red, sjena_green, sjena_blue));
		putpixel(aktivni,x - 1, y,makecol(sjena_red, sjena_green, sjena_blue));
		putpixel(aktivni,x - 1, y + 1,makecol(sjena_red, sjena_green, sjena_blue));
		putpixel(aktivni,x, y - 1,makecol(sjena_red, sjena_green, sjena_blue));
		putpixel(aktivni,x, y,makecol(sjena_red, sjena_green, sjena_blue));
		putpixel(aktivni,x, y + 1,makecol(sjena_red, sjena_green, sjena_blue));
		putpixel(aktivni,x + 1, y - 1,makecol(sjena_red, sjena_green, sjena_blue));
		putpixel(aktivni,x + 1, y,makecol(sjena_red, sjena_green, sjena_blue));
		putpixel(aktivni,x + 1, y + 1,makecol(sjena_red, sjena_green, sjena_blue));
	}
  if (tenk[igrac].aktivno_oruzje != 0)
		blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
  if (broj_pogleda == 128)
	{
		aktivni = monitor;
		putpixel(aktivni,80 + x_missle * 0.75, y_missle * 0.75,makecol(255,255,255));
	}
}

void
eksplozija (double x_poc, double y_poc, double z_poc,
						double xy_kut_projektila, double z_kut_projektila)
{
  int br, br1;
  int x, y;
  time_t t;
  double brzina, xy_kut, z_kut;
  int flag;
  double x_provjera, y_provjera, z_provjera;
  int broj_srapnela;
  int broj_koraka;
  int more;

  struct
  {
    double x, y, z;
    double x_pomak, y_pomak, z_pomak;
  }
  srapnel[500];

  time (&t);
  srand (t);

	debug_message("play sample: explosion");
	si3dsound(explosion);

  broj_srapnela = oruzje[tenk[igrac].aktivno_oruzje].jacina * 25;
  more = 0;
  broj_koraka = 60;
  if (reljef[(int) x_poc][(int) y_poc].vis <= 0)
	{
		more = 1;
		broj_srapnela = 199;
	}
  if (z_poc < 0)
    z_poc = 0;

  for (br = 0; br < broj_srapnela; br++)
	{
		srapnel[br].x = x_poc;
		srapnel[br].y = y_poc;
		srapnel[br].z = z_poc;
		brzina = 5 + (10.0 * rand () / (RAND_MAX + 5.0));
		xy_kut =
			((xy_kut_projektila - PI) * 100 - 140 +
			 280.0 * rand () / (RAND_MAX + 1.0)) / 100;
		z_kut =
			(PI / 2 + z_kut_projektila + 0.5) * 1.0 * rand () / (RAND_MAX + 1.0);
		srapnel[br].x_pomak = brzina * sin (z_kut) * cos (xy_kut);
		srapnel[br].y_pomak = brzina * sin (z_kut) * sin (xy_kut);
		srapnel[br].z_pomak = brzina * cos (z_kut);
	}

	aktivni = pogled;
  crtaj_tenk (igrac);
  for (br = 0; br < broj_koraka; br++)
	{
		aktivni = pogled;
		blit (aktivni, za_monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		aktivni = za_monitor;

		for (br1 = 0; br1 < broj_srapnela; br1++)
		{
			x_provjera = srapnel[br1].x;
			y_provjera = srapnel[br1].y;
			z_provjera = reljef[(int) srapnel[br1].x][(int) srapnel[br1].y].vis;
			flag = 1;

			do
	    {
	      y_provjera += 2;
	      z_provjera += 1;
	      if (reljef[(int) x_provjera][(int) y_provjera].vis >
						z_provjera + 5)
					flag = 0;
	    }
			while (y_provjera < 500);

			srapnel[br1].x += srapnel[br1].x_pomak;
			srapnel[br1].y += srapnel[br1].y_pomak;
			srapnel[br1].z += srapnel[br1].z_pomak;
			if (srapnel[br1].z <
					reljef[(int) srapnel[br1].x][(int) srapnel[br1].y].vis
					|| srapnel[br1].z < 0)
	    {
	      srapnel[br1].x_pomak = 0;
	      srapnel[br1].y_pomak = 0;
	      srapnel[br1].z_pomak = 0.8;
	    }
			srapnel[br1].x_pomak *= 0.85;
			srapnel[br1].y_pomak *= 0.85;
			srapnel[br1].z_pomak -= 0.8;
			x = (int) srapnel[br1].x;
			y = (int) (150 - srapnel[br1].z + srapnel[br1].y / 2);
			if (x > 0 && x < 640 && y > 0 && y < 480 && flag == 1)
	    {
	      if (more == 0)
					putpixel(aktivni,x, y,makecol(90,90,90));
	      if (more == 0)
					putpixel(aktivni,x+1, y,makecol(90,90,90));
	      if (more == 1)
					putpixel(aktivni,x, y,makecol(150,150,240));
	      if (more == 1)
					putpixel(aktivni,x+1, y,makecol(150,150,240));
	    }
		}
		blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	}
	aktivni = monitor;
  if (more == 0)
	{
		blit (aktivni,pogled, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		for (br = 0; br < broj_srapnela; br++)
		{
			reljef[(int) srapnel[br].x][(int) srapnel[br].y].sjena += 50;
			if (reljef[(int) srapnel[br].x][(int) srapnel[br].y].sjena > 255)
				reljef[(int) srapnel[br].x][(int) srapnel[br].y].sjena = 255;
			reljef[(int) srapnel[br].x + 1][(int) srapnel[br].y].sjena += 50;
			if (reljef[(int) srapnel[br].x + 1][(int) srapnel[br].y].sjena >
					255) reljef[(int) srapnel[br].x][(int) srapnel[br].y].sjena =
								 255;
		}
	}
}

void
baci ()
{
  double radijus, udaljenost, x_centar, y_centar;
  int x, y, boja;

  radijus = 5 + (6.0 * random () / (RAND_MAX + 5.0));
  x_centar =
    1.5 * radijus + (30.0 - radijus * 3.0) * random () / (RAND_MAX +
																													radijus * 1.5);
  y_centar =
    1.5 * radijus + (30.0 - radijus * 3.0) * random () / (RAND_MAX +
																													radijus * 1.5);
  for (x = 0; x < 30; x++)
    for (y = 0; y < 30; y++)
		{
			udaljenost =
				sqrt ((x_centar - x) * (x_centar - x) +
							(y_centar - y) * (y_centar - y));
			if (udaljenost < radijus)
			{
				boja = 150 + (105.0 * random () / (RAND_MAX + 150.0));
				putpixel(aktivni,x,y,makecol(r[boja], g[boja], b[boja]));
			}
		}
}

void
eksplodira_tenk (int koji)
{
  int br;
	BITMAP *explozija;
  int x, y;
  BITMAP *eksp, *prije;
  
  int brojac, vrijeme, ispucanih;
  double r_boja, g_boja, b_boja, xp, yp, zp;
  int r_g, r_d, r_l, r_D;
  int g_g, g_d, g_l, g_D;
  int b_g, b_d, b_l, b_D;
  int X, Y, flag;

	talk(DIE, koji);

  xp = tenk[koji].x;
  yp = tenk[koji].y;
  zp = tenk[koji].z + 3;
  flag = 1;

  eksp = create_bitmap(30,30);
  explozija = create_bitmap(30,30);
  prije = create_bitmap(30,30);
  
  do
	{
		yp++;
		zp += 0.5;
		if (reljef[(int) xp][(int) yp].vis > zp)
			flag = 0;
	}
  while (yp < 640);

  if (tenk[koji].z <= 0 || tenk[koji].mrtav == 1)
    flag = 0;

  if (flag == 1)
	{
		for (br = 0; br < 256; br++)
		{
			r[br] = 255;
			g[br] = br;
			b[br] = 20;
		}

		aktivni = explozija;
		brojac = 0;
		vrijeme = 0;
		ispucanih = 0;

		aktivni = za_monitor;
		X = (int) tenk[koji].x - 15;
		Y =
			(int) (150 - reljef[(int) tenk[koji].x][(int) tenk[koji].y].vis +
						 tenk[koji].y / 2) - 15;
		blit(aktivni,prije,X,Y,0,0,30,30);
      
		for (br = 0; br < 150; br++)
		{
			aktivni = explozija;
			if (brojac++ > vrijeme && ispucanih++ < 50)
	    {
	      baci ();
	      brojac = 0;
	      vrijeme = 6;	//+(20.0*random()/(RAND_MAX+10.0));
	    }
			for (x = 1; x < 30; x++)
				for (y = 1; y < 30; y++)
	      {
					r_g = getr(getpixel(aktivni,x,y-1));
					g_g = getg(getpixel(aktivni,x,y-1));
					b_g = getb(getpixel(aktivni,x,y-1));
					r_d = getr(getpixel(aktivni,x,y+1));
					g_d = getg(getpixel(aktivni,x,y+1));
					b_d = getb(getpixel(aktivni,x,y+1));
					r_l = getr(getpixel(aktivni,x-1,y));
					g_l = getg(getpixel(aktivni,x-1,y));
					b_l = getb(getpixel(aktivni,x-1,y));
					r_D = getr(getpixel(aktivni,x+1,y));
					g_D = getg(getpixel(aktivni,x+1,y));
					b_D = getb(getpixel(aktivni,x+1,y));
					r_boja = r[(int) ((r_g + r_d + r_l + r_D) / 4 - 4)];
					g_boja = g[(int) ((g_g + g_d + g_l + g_D) / 4 - 4)];
					b_boja = b[(int) ((b_g + b_d + b_l + b_D) / 4 - 4)];
					if (r_boja < 0)
						r_boja = 0;
					if (g_boja < 0)
						g_boja = 0;
					if (b_boja < 0)
						b_boja = 0;

					if (g_boja < 70)
						putpixel(aktivni,x,y,makecol(255,0,255));
					else
						putpixel(aktivni,x,y,makecol(r_boja, g_boja, b_boja));
	      }

			blit(aktivni,eksp,0,0,0,0,30,30);
          
			aktivni = za_monitor;
			blit(prije,aktivni,0,0,X,Y,30,30);
        
			masked_blit(eksp,aktivni,1,1,X,Y,28,28);
        
			blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		}

		destroy_bitmap(explozija);
		aktivni = za_monitor;
		blit(prije, aktivni, 0,0,X,Y,30,30);
        
		blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	}
  destroy_bitmap(eksp);
  destroy_bitmap(prije);
}

void
zacrni (int x_missle, int y_missle, int z_missle)
{
  int x, y;
  double radijus;

	aktivni = monitor;

  for (x = x_missle - 10; x < x_missle + 11; x++)
    for (y = y_missle - 10; y < y_missle + 11; y++)
		{
			radijus =
				sqrt ((x - x_missle) * (x - x_missle) +
							(y - y_missle) * (y - y_missle));
			if (radijus < 10)
				reljef[x][y].sjena += sqrt (10 - radijus) * 30;
		}

//      for (br=0; br<10000; br++)
//      for (br1=0; br1<3000; br1++);

  iscrtaj_reljef (2, x_missle - 10, x_missle + 10, 0, 640);
}

void
atomska (int x_missle, int y_missle, int z_missle)
{
  int x, y;
  double radijus;

	aktivni = monitor;

	graphics = load("ATOMIC");
	masked_blit(graphics[0].dat, aktivni, 0, 0, 
							x_missle - 50, 
							90 - z_missle + y_missle / 2, 79, 100);
	unload(graphics);
	rest(1000);

  for (x = x_missle - 50; x < x_missle + 51; x++)
    for (y = y_missle - 50; y < y_missle + 51; y++)
		{
			radijus =
				sqrt ((x - x_missle) * (x - x_missle) +
							(y - y_missle) * (y - y_missle));
			if (radijus < 50)
				reljef[x][y].sjena += sqrt (50 - radijus) * 15;
		}

  iscrtaj_reljef (2, x_missle - 50, x_missle + 51, 0, 640);
}

static int
check_round_end (void)
{
	int broj, br;

	broj = -1;
  for (br = 0; br < broj_igraca; br++)
    if (tenk[br].energija > 0)
		{
			if (broj == -1)
				broj = tenk[br].broj;
			else if (broj != tenk[br].broj)
				break;
		}

	if (br < broj_igraca)
		return 0;

	return 1;
}

void
baci_projektil ()
{
  double x_missle, y_missle, z_missle, radijus_missle, x, y, radijus;
  double x_missle_pomak, y_missle_pomak, z_missle_pomak;
  double x_pomak, y_pomak;
  int flag;
  long int br, br1;
  double udaljenost, gubi, gubiold;
  double kut_projektila_xy, kut_projektila_z;
  double pomak, smanji;
  int ao, fl;
  double z1, z2, z3, z4;
  int brojac;
  float x_d, y_d, z_d;
  int dohvat;

  if (tenk[igrac].aktivno_oruzje > 0)
		talk(KILL, igrac);
	
	debug_message("play sample: fire projectile");
	si3dsound(fire);

  if (tenk[igrac].aktivno_oruzje > 1)
		tenk[igrac].w[tenk[igrac].aktivno_oruzje]--;
	
  tenk[igrac].ap -= oruzje[tenk[igrac].aktivno_oruzje].trosi_ap;

  radijus_missle = oruzje[tenk[igrac].aktivno_oruzje].radijus;

  x_missle = tenk[igrac].x + tenk[igrac].x_projektil;
  y_missle = tenk[igrac].y + tenk[igrac].y_projektil;
  z_missle = tenk[igrac].z + tenk[igrac].z_projektil;
  x_missle_pomak = 12 * tenk[igrac].x_pomak;
  y_missle_pomak = 12 * tenk[igrac].y_pomak;
  z_missle_pomak = 12 * tenk[igrac].z_pomak;

  flag = 0;
  do
	{
		crtaj_projektil (x_missle, y_missle, z_missle);
		x_missle += x_missle_pomak;
		y_missle += y_missle_pomak;
		z_missle += z_missle_pomak;
		x_missle_pomak = x_missle_pomak * 0.99 + x_pomak_vjetra / 30;
		y_missle_pomak = y_missle_pomak * 0.99 - y_pomak_vjetra / 30;
		z_missle_pomak -= 0.4;

		if (tenk[igrac].aktivno_oruzje == 0)
			for (br = 0; br < 1000; br++)
				for (br1 = 0; br1 < 300; br1++);

		if (x_missle > 640 - radijus_missle || x_missle < radijus_missle
				|| y_missle > 640 - radijus_missle || y_missle < radijus_missle
				|| z_missle > 500)
			flag = 1;
	}
  while (z_missle > reljef[(int) x_missle][(int) y_missle].vis && z_missle > 0
				 && flag == 0);

  ao = tenk[igrac].aktivno_oruzje;

  brojac = 0;
  if (ao == 8)
    do
		{
			crtaj_projektil (x_missle, y_missle,
											 reljef[(int) x_missle][(int) y_missle].vis);
			fl = 1;
			z1 = reljef[(int) x_missle - 5][(int) y_missle].vis;
			z2 = reljef[(int) x_missle + 5][(int) y_missle].vis;
			z3 = reljef[(int) x_missle][(int) y_missle - 5].vis;
			z4 = reljef[(int) x_missle][(int) y_missle + 5].vis;
			x_pomak = (z1 - z2) / 15;
			y_pomak = (z3 - z4) / 15;
			if (x_pomak > 0.1 || y_pomak > 0.1)
			{
				x_missle_pomak = x_pomak;
				y_missle_pomak = y_pomak;
			}
			else
			{
				x_pomak = x_missle_pomak;
				y_pomak = y_missle_pomak;
			}
			do
			{
				flag = 0;
				if (x_pomak > 2 || y_pomak > 2)
	      {
					x_pomak = x_pomak / 1.1;
					y_pomak = y_pomak / 1.1;
					flag = 1;
	      }
			}
			while (flag == 1);
			x_missle += x_pomak;
			y_missle += y_pomak;
			if (reljef[(int) x_missle][(int) y_missle].vis < 0)
				fl = 0;
			for (br = 0; br < broj_igraca; br++)
			{
				x_d = tenk[br].x - x_missle;
				y_d = tenk[br].y - y_missle;
				z_d =
					reljef[(int) tenk[br].x][(int) tenk[br].y].vis -
					reljef[(int) x_missle][(int) y_missle].vis;
				udaljenost = sqrt (x_d * x_d + y_d * y_d + z_d * z_d);
				if (udaljenost < 30)
					fl = 0;
			}
			brojac++;
			if (brojac > 500)
				fl = 0;
		}
    while (fl == 1);

  if (flag == 0)
	{
		for (x = x_missle - radijus_missle; x < x_missle + radijus_missle; x++)
			for (y = y_missle - radijus_missle; y < y_missle + radijus_missle;
					 y++)
			{
				radijus =
					sqrt ((x - x_missle) * (x - x_missle) +
								(y - y_missle) * (y - y_missle));
				if (radijus < radijus_missle)
	      {
					smanji = radijus_missle - radijus;
					if (tenk[igrac].aktivno_oruzje == 3)
						smanji = sqrt (radijus_missle - radijus) * 10;
					if (x > 0 && x < 640 && y > 0 && y < 640 && ao != 6)
						reljef[(int) x][(int) y].vis -= smanji;
					if (x > 0 && x < 640 && y > 0 && y < 640 && ao == 6)
						reljef[(int) x][(int) y].vis += sqrt (smanji * 6);
	      }
			}


		if (ao != 0 && ao != 4)
			iscrtaj_reljef (2, x_missle - radijus_missle - 3,
											x_missle + radijus_missle + 3, 0, 640);

		kut_projektila_xy =
			atan2 (y_missle - tenk[igrac].y, x_missle - tenk[igrac].x);
		pomak =
			sqrt (x_missle_pomak * x_missle_pomak +
						y_missle_pomak * y_missle_pomak);
		kut_projektila_z = atan2 (z_missle_pomak, pomak);
		if (ao != 0 && ao != 3 && ao != 4 && ao != 7)
			eksplozija (x_missle, y_missle, z_missle, kut_projektila_xy,
									kut_projektila_z);
		if (ao == 4)
			zacrni ((int) x_missle, (int) y_missle, (int) z_missle);
		if (ao == 7)
			atomska ((int) x_missle, (int) y_missle, (int) z_missle);
		if (tenk[igrac].aktivno_oruzje != 0)
			for (br = 0; br < broj_igraca; br++)
				iscrtaj_reljef (2, tenk[br].x - 20, tenk[br].x + 20, 0, 640);

		for (br = 0; br < broj_igraca; br++)
		{
			udaljenost =
				sqrt ((x_missle - tenk[br].x) * (x_missle - tenk[br].x) +
							(y_missle - tenk[br].y) * (y_missle - tenk[br].y) +
							(reljef[(int) tenk[br].x][(int) tenk[br].y].vis -
							 reljef[(int) x_missle][(int) y_missle].vis) *
							(reljef[(int) tenk[br].x][(int) tenk[br].y].vis -
							 reljef[(int) x_missle][(int) y_missle].vis));
			dohvat = oruzje[tenk[igrac].aktivno_oruzje].radijus;
			if (ao == 7)
				dohvat = 100;
			gubi =
				(2 * dohvat -
				 udaljenost) * oruzje[tenk[igrac].aktivno_oruzje].jacina;
			gubiold = 0;
			if (tenk[br].stit > 0)
	    {
	      gubiold = gubi;
	      gubi = gubi * 10 / tenk[br].stit;
	      if (gubiold > tenk[br].stit)
					gubiold = tenk[br].stit;
	      if (gubi > 0)
					tenk[br].stit -= (int) gubiold;
	      if (tenk[br].stit < 0)
					tenk[br].stit = 0;
	    }
			if (reljef[(int) tenk[br].x][(int) tenk[br].y].vis <= 0)
				gubi = 100;
			if (gubi > tenk[br].energija)
				gubi = tenk[br].energija;
			if (gubi > 0)
	    {
	      tenk[br].energija -= (int) gubi;
	      tenk[igrac].ukupna_steta += gubi;
	    }
			if (tenk[br].energija < 0)
				tenk[br].energija = 0;
			if (gubi > 0)
	    {
				aktivni = monitor;
				boja_fonta = makecol(170, 30, 30);
				textprintf(aktivni, font, tenk[br].x, 120 - tenk[br].z + tenk[br].y / 2, boja_fonta,"%i",
									 -1 * (int) gubi);
				boja_fonta = makecol(230,230,30);
	      if (gubiold > 0)
					textprintf(aktivni, font, tenk[br].x, 105 - tenk[br].z + tenk[br].y / 2, boja_fonta,"%i",
										 -1 * (int) gubiold);
	

				sleep (1);
	    }
		}
	}

  if (tenk[igrac].aktivno_oruzje == 0)
		sleep (2);
	
  for (br = 0; br < broj_igraca; br++)
    if (tenk[br].energija == 0)
		{
			aktivni = pogled;
			crtaj_tenk (br);
			aktivni = za_monitor;
			crtaj_tenk (br);
			blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
			eksplodira_tenk (br);
			tenk[br].mrtav = 1;
		}

	if (check_round_end ())
		end_round ();
}

void
provjera_dodira (void)
{
  int br, br1, x;

  kontrola = 1;
  for (br = 0; br < broj_igraca; br++)
	{
		if ((br != igrac) &&
				(abs (tenk[igrac].x - tenk[br].x) < 20) &&
				(abs (tenk[igrac].y - tenk[br].y) < 20))
		{
			kontrola = 0;
		}
	}
  for (br = 0; br < broj_poklona; br++)
	{
		if ((abs (tenk[igrac].x - poklon[br].x - 15) < 25) &&
				(abs (tenk[igrac].y - poklon[br].y - 20) < 25))
		{
			if (poklon[br].vrsta == 1)
	    {
	      tenk[igrac].energija += 25;
	      if (tenk[igrac].energija > 100)
					tenk[igrac].energija = 100;
	    }
			if (poklon[br].vrsta == 2)
	    {
	      tenk[igrac].energija += 50;
	      if (tenk[igrac].energija > 100)
					tenk[igrac].energija = 100;
	    }
			if (poklon[br].vrsta == 3)
				tenk[igrac].stit = 100;
			if (poklon[br].vrsta == 4)
				tenk[igrac].ap += 5;
			if (poklon[br].vrsta == 5)
				tenk[igrac].mp += 10;
			if (poklon[br].vrsta == 6)
				tenk[igrac].w[poklon[br].oruzje] += 3;
			x = poklon[br].x;
			for (br1 = br; br1 < broj_poklona - 1; br1++)
				poklon[br1] = poklon[br1 + 1];
			broj_poklona--;
			iscrtaj_reljef (2, x, x + 20, 0, 640);
		}
	}
}

void
baci_smece ()
{
  double i_pomak_l, j_pomak_l;
  int r = 0, g = 0, b = 0;
  int sjena;
  int flag;
  double x, y, z;

  x = tenk[igrac].x;
  y = tenk[igrac].y;
  z = tenk[igrac].z + 3;
  flag = 1;

  do
	{
		y++;
		z += 0.5;
		if (reljef[(int) x][(int) y].vis > z)
			flag = 0;
	}
  while (y < 640);

	aktivni = pogled;

  i_pomak_l = cos (tenk[igrac].kut + 0.31416) * 10;
  j_pomak_l = sin (tenk[igrac].kut + 0.31416) * 10;
  reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)
																					 (tenk[igrac].y -
																						j_pomak_l)].sjena += 15;
	r = getr(getpixel(aktivni,(int) (tenk[igrac].x - i_pomak_l),
										150 -reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)(tenk[igrac].y -j_pomak_l)].vis +(tenk[igrac].y - j_pomak_l) / 2 ));
	g = getg(getpixel(aktivni,(int) (tenk[igrac].x - i_pomak_l),
										150 -reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)(tenk[igrac].y -j_pomak_l)].vis +(tenk[igrac].y - j_pomak_l) / 2 ));
	b = getb(getpixel(aktivni,(int) (tenk[igrac].x - i_pomak_l),
										150 -reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)(tenk[igrac].y -j_pomak_l)].vis +(tenk[igrac].y - j_pomak_l) / 2 ));
  sjena =
    reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)
																						 (tenk[igrac].y -
																							j_pomak_l)].sjena;
  r -= (int) (sjena / 2);
  g -= (int) (sjena / 2);
  b -= (int) (sjena / 2);
  if (r < 0)
    r = 0;
  if (g < 0)
    g = 0;
  if (b < 0)
    b = 0;
  if (flag == 1)
		putpixel(aktivni,tenk[igrac].x - i_pomak_l,150 -reljef[(int) (tenk[igrac].x - i_pomak_l)][(int) 
																																														 (tenk[igrac].y -j_pomak_l)].vis + (tenk[igrac].y - j_pomak_l) / 2, makecol(r, g, b));
  i_pomak_l = cos (tenk[igrac].kut - 0.31416) * 10;
  j_pomak_l = sin (tenk[igrac].kut - 0.31416) * 10;
  reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)
																					 (tenk[igrac].y -
																						j_pomak_l)].sjena += 15;
	r = getr(getpixel(aktivni,(int) (tenk[igrac].x - i_pomak_l),
										150 -reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)(tenk[igrac].y -j_pomak_l)].vis +(tenk[igrac].y - j_pomak_l) / 2 ));
	g = getg(getpixel(aktivni,(int) (tenk[igrac].x - i_pomak_l),
										150 -reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)(tenk[igrac].y -j_pomak_l)].vis +(tenk[igrac].y - j_pomak_l) / 2 ));
	b = getb(getpixel(aktivni,(int) (tenk[igrac].x - i_pomak_l),
										150 -reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)(tenk[igrac].y -j_pomak_l)].vis +(tenk[igrac].y - j_pomak_l) / 2 ));
  sjena =
    reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)
																						 (tenk[igrac].y -
																							j_pomak_l)].sjena;
  r -= sjena;
  g -= sjena;
  b -= sjena;
  if (r < 0)
    r = 0;
  if (g < 0)
    g = 0;
  if (b < 0)
    b = 0;
  if (flag == 1)
		putpixel(aktivni,tenk[igrac].x - i_pomak_l,150 -reljef[(int) (tenk[igrac].x - i_pomak_l)][(int)
																																														 (tenk[igrac].y -j_pomak_l)].vis + (tenk[igrac].y - j_pomak_l) / 2, makecol(r, g, b));
}

void
baci_poklon ()
{
  time_t t;
  double z, grav;
  int predizbor, izbor = 0, izbor_vrsta = 0, br, br1;
  BITMAP *prije;
  int X, Y;
  int x_pada, y_pada, x_pomak = 0, y_pomak = 0;
  double xp, yp, zp;
  int flag;

  prije = create_bitmap(20,20);
  
  time (&t);
  srand (t);

  predizbor = 1 + (42.0 * rand () / (RAND_MAX + 1.0));
  if (predizbor <= 10)
    izbor = 1;
  if (predizbor > 10 && predizbor <= 13)
    izbor = 2;
  if (predizbor > 13 && predizbor <= 17)
    izbor = 3;
  if (predizbor > 17 && predizbor <= 22)
    izbor = 4;
  if (predizbor > 22 && predizbor <= 27)
    izbor = 5;
  if (predizbor > 27 && predizbor <= 42)
    izbor = 6;
  x_pada = 30 + (550.0 * rand () / RAND_MAX + 30.0);
  y_pada = 30 + (550.0 * rand () / RAND_MAX + 30.0);
  if (izbor == 6)
    izbor_vrsta = 2 + (6.0 * rand () / (RAND_MAX + 2.0));
  if (reljef[(int) x_pada][(int) y_pada].vis > 0)
	{
		if (izbor == 1)
			x_pomak = y_pomak = 12;
		if (izbor == 2)
			x_pomak = y_pomak = 16;
		if (izbor == 3)
			x_pomak = y_pomak = 8;
		if (izbor == 4)
			x_pomak = y_pomak = 10;
		if (izbor == 5)
			x_pomak = y_pomak = 10;
		if (izbor == 6)
			x_pomak = y_pomak = 16;
		aktivni = za_monitor;
		xp = x_pada;
		yp = y_pada;
		zp = reljef[(int) xp][(int) yp].vis;
		flag = 1;

		do
		{
			yp++;
			zp += 0.5;
			if (reljef[(int) xp][(int) yp].vis > zp)
				flag = 0;
		}
		while (yp < 640);
		if (reljef[(int) xp][(int) yp].vis < 0)
			flag = 0;

		for (X = x_pada; X < x_pada + x_pomak; X++)
			for (Y = y_pada + 15; Y < y_pada + y_pomak + 15; Y++)
				if (flag == 1)
					putpixel(aktivni, X,150 - reljef[X][Y].vis + (int) (Y / 2),makecol(130,130,130));

		poklon[broj_poklona].vrsta = izbor;
		poklon[broj_poklona].x = x_pada;
		poklon[broj_poklona].y = y_pada;
		poklon[broj_poklona].oruzje = izbor_vrsta;
		broj_poklona++;
	}
  z = (int) (y_pada / 2 + 149);
  grav = 0.3;
  do
	{
		z -= grav;
		grav += 0.2;

		xp = x_pada;
		yp = y_pada;
		zp = z;
		flag = 1;

		do
		{
			yp++;
			zp += 0.5;
			if (reljef[(int) xp][(int) yp].vis > zp)
				flag = 0;
		}
		while (yp < 640);

		if (flag == 1)
		{
			aktivni = za_monitor;
			blit(aktivni, prije, (int) x_pada, (int) (150 - z + y_pada / 2),0,0,20,20);
			if (izbor == 1)
				masked_blit(small_health,aktivni,0,0,(int) x_pada, (int) (150 - z + y_pada / 2),15,15);
			if (izbor == 2)
				masked_blit(big_health,aktivni,0,0,(int) x_pada, (int) (150 - z + y_pada / 2),20,20);          
			if (izbor == 3)
				masked_blit(shield,aktivni,0,0,(int) x_pada, (int) (150 - z + y_pada / 2),12,12);          
			if (izbor == 4)
				masked_blit(ap,aktivni,0,0,(int) x_pada, (int) (150 - z + y_pada / 2),12,12);          
			if (izbor == 5)
				masked_blit(mp,aktivni,0,0,(int) x_pada, (int) (150 - z + y_pada / 2),12,12);          
			if (izbor == 6)
				masked_blit(weapon,aktivni,0,0,(int) x_pada, (int) (150 - z + y_pada / 2),20,20);          
			blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
			for (br = 0; br < 10000; br++)
				for (br1 = 0; br1 < 50; br1++);
			blit(prije,aktivni,0,0,(int) x_pada, (int) (150 - z + y_pada / 2),20,20);          
		}
	}
  while (z > reljef[(int) x_pada][(int) y_pada].vis);

	aktivni = pogled;
  if (reljef[(int) x_pada][(int) y_pada].vis > 0)
	{
		xp = x_pada;
		yp = y_pada;
		zp = reljef[(int) x_pada][(int) y_pada].vis;
		flag = 1;

		do
		{
			yp++;
			zp += 0.5;
			if (reljef[(int) xp][(int) yp].vis > zp)
				flag = 0;
		}
		while (yp < 640);

		if (flag == 1)
		{
			if (izbor == 1)
				masked_blit(small_health,aktivni,0,0,(int) x_pada, (int) (150- reljef[(int) x_pada][(int) y_pada].vis +y_pada/2),15,15);
			if (izbor == 2)
				masked_blit(big_health,aktivni,0,0,(int) x_pada, (int) (150- reljef[(int) x_pada][(int) y_pada].vis +y_pada/2),20,20);            
			if (izbor == 3)
				masked_blit(shield,aktivni,0,0,(int) x_pada, (int) (150- reljef[(int) x_pada][(int) y_pada].vis +y_pada/2),12,12);            
			if (izbor == 4)
				masked_blit(ap,aktivni,0,0,(int) x_pada, (int) (150- reljef[(int) x_pada][(int) y_pada].vis +y_pada/2),12,12);            
			if (izbor == 5)
				masked_blit(mp,aktivni,0,0,(int) x_pada, (int) (150- reljef[(int) x_pada][(int) y_pada].vis +y_pada/2),12,12);            
			if (izbor == 6)
				masked_blit(weapon,aktivni,0,0,(int) x_pada, (int) (150- reljef[(int) x_pada][(int) y_pada].vis +y_pada/2),20,20);            
		}
	}
	blit (aktivni, za_monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	aktivni = za_monitor;
	crtaj_tenk (igrac);
	blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

	destroy_bitmap(prije  );
        
}
  
