# Makefile for Scorched Island 3D for compiling with WATCOM

WCL = wcl386.exe
CFLAGS = /dDOS /s /3s
LFLAGS = /k128k

all: si3d-386.exe

si3d-386.exe: glavni.obj sucelje.obj init.obj prikaz.obj borba.obj intro.obj karta.obj
	$(WCL) glavni.obj sucelje.obj init.obj prikaz.obj borba.obj intro.obj karta.obj alleg.lib /k128k /fe=si3d-386.exe

glavni.obj: glavni.c
	$(WCL) $(CFLAGS) glavni.c

sucelje.obj: sucelje.c
	$(WCL) $(CFLAGS) sucelje.c

init.obj: init.c
	$(WCL) $(CFLAGS) init.c

prikaz.obj: prikaz.c
	$(WCL) $(CFLAGS) prikaz.c

borba.obj: borba.c
	$(WCL) $(CFLAGS) borba.c

intro.obj: intro.c
	$(WCL) $(CFLAGS) intro.c

karta.obj: karta.c
	$(WCL) $(CFLAGS) karta.c


