%define name si3d
%define version 1.2
%define release 1mdk

Name: %{name}
Summary: Scorched Island 3D is a popular 'shoot-over-the-hill' game
Version: %{version}
Release: %{release}
Source: http://cvs.linux.hr/si3d/si3d-1.2.tar.gz
URL: http://cvs.linux.hr/si3d/
Copyright: GPL
Group: Games/Strategy
BuildRoot: %{_tmppath}/%{name}-buildroot
# Docdir: /usr/share/doc
Requires: /bin/sh

%description
Scorched Island 3D is a clone of popular dos game called Scorched Earth,
but this one is in three dimensions. It is a game where you try to
shoot your opponent over the hill with different weapons and such 
(very similar to Worms too).

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q

%build
make

%install
[ -d $RPM_BUILD_ROOT ] && rm -r $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_datadir}
mkdir -p $RPM_BUILD_ROOT/%{_defaultdocdir}
mkdir -p $RPM_BUILD_ROOT/%{_menudir}
cp -f si3d $RPM_BUILD_ROOT/%{_bindir}/si3d
mkdir $RPM_BUILD_ROOT/%{_datadir}/si3d
cp -R talk.die talk.kil si3d.dat $RPM_BUILD_ROOT/%{_datadir}/si3d
mkdir $RPM_BUILD_ROOT/%{_defaultdocdir}/si3d-%{version}
cp manual-en.txt manual-hr.txt AUTHORS COPYING ChangeLog TODO $RPM_BUILD_ROOT/%{_defaultdocdir}/si3d-%{version}
echo << EOF > $RPM_BUILD_ROOT/%{_menudir}/si3d
?package(si3d):command="/usr/bin/si3d" icon="si3d.xpm" \
	needs="X11" section="Amusement/Strategy" title="Scorched Island 3D" \
	longtitle="A popular 'shoot-over-the-hill' game"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,0755)
%doc AUTHORS manual-en.txt manual-hr.txt README TODO BUGS COPYING ChangeLog
%{_bindir}/si3d
%{_datadir}/si3d/
%{_menudir}/si3d

%changelog
* Sat Dec 29 2001 Vlatko Kosturjak <kost@iname.com> 1.2-1
- added support for new version (1.2) + dat file
* Sat Dec 23 2000 Vlatko Kosturjak <kost@iname.com> 1.1.1-3
- fixed bug in support for menu system
* Fri Dec 22 2000 Vlatko Kosturjak <kost@iname.com> 1.1.1-2
- added support for menu system
- fixed chkconfig bug (we don't need it!)
* Sun Dec 10 2000 Vlatko Kosturjak <kost@iname.com> 1.1.1
- initial version
